Attribute VB_Name = "modFTP"
Option Explicit

Public Const SapphireFTPLicence = 1234567890

' Error codes
Public Const FTP_NO_ERROR = 0
Public Const FTP_TOO_MANY_INTERNET_HANDLES = 1
Public Const FTP_TIMEOUT = 2
Public Const FTP_INTERNAL_ERROR = 3
Public Const FTP_INVALID_URL = 4
Public Const FTP_NAME_NOT_RESOLVED = 5
Public Const FTP_PROTOCOL_NOT_FOUND = 6
Public Const FTP_SHUTDOWN = 7
Public Const FTP_INCORRECT_USER_NAME = 8
Public Const FTP_INCORRECT_PASSWORD = 9
Public Const FTP_LOGIN_FAILED = 10
Public Const FTP_REQUEST_PENDING = 11
Public Const FTP_CANNOT_CONNECT = 12
Public Const FTP_CONNECTION_ABORTED = 13
Public Const FTP_CONNECTION_RESET = 14
Public Const FTP_FORCE_RETRY = 15
Public Const FTP_INVALID_PROXY_REQUEST = 16
Public Const FTP_TRANSFER_IN_PROGRESS = 17
Public Const FTP_DROPPED = 18
Public Const FTP_NO_PASSIVE_MODE = 19
Public Const FTP_LOCAL_FILE_EXISTS = 20
Public Const FTP_UNKNOWN = 21

' Overwrite modes
Public Const FTP_OVERWRITE = 1
Public Const FTP_DONT_OVERWRITE = 0

' Transfer modes
Public Const FTP_TRANSFER_UNKNOWN = 0
Public Const FTP_TRANSFER_ASCII = 1
Public Const FTP_TRANSFER_BINARY = 2

Public Const DEFAULT_FTP_PORT = 21

' Timeout in miliseconds
Public Const FTP_TIMEOUT_SETTING = 10000

Public Declare Function sFTPOpen Lib "SapphireFTP.dll" (ByVal sServer As String, ByVal lPort As Long, ByVal sUser As String, ByVal sPwd As String, ByVal lPassive As Long, ByVal lTimeout As Long, ByVal lLicence As Long) As Long
Declare Function sFTPGet Lib "SapphireFTP.dll" (ByVal sRemoteFile As String, ByVal sLocalFile As String, ByVal bOverWriteFile As Long, ByVal lTransferType As Long, ByVal lLicence As Long) As Long
Declare Function sFTPPull Lib "SapphireFTP.dll" (ByVal sRemoteFile As String, ByVal sLocalFile As String, ByVal bOverWriteFile As Long, ByVal lTransferType As Long, ByVal lLicence As Long) As Long
Declare Function sFTPPut Lib "SapphireFTP.dll" (ByVal sLocalFile As String, ByVal sRemoteFile As String, ByVal lTransferType As Long, ByVal lLicence As Long) As Long
Declare Function sFTPPush Lib "SapphireFTP.dll" (ByVal sLocalFile As String, ByVal sRemoteFile As String, ByVal lTransferType As Long, ByVal lLicence As Long) As Long
Declare Function sFTPClose Lib "SapphireFTP.dll" (ByVal lLicense As Long) As Long

Declare Function sFTPChangeDirectory Lib "SapphireFTP.dll" (ByVal sPath As String, ByVal lLicence As Long) As Long
Declare Function sFTPCurrentDirectory Lib "SapphireFTP.dll" (ByVal sCurrentDirectory As String, ByVal lLicence As Long) As Long
Declare Function sFTPFileExists Lib "SapphireFTP.dll" (ByVal sFile As String, ByVal lLicence As Long) As Long
Declare Function sFTPFindFirstFile Lib "SapphireFTP.dll" (ByVal sFileString As String, ByVal sFilter As String, ByVal lLicence As Long) As Long
Declare Function sFTPFindNextFile Lib "SapphireFTP.dll" (ByVal sFileString As String, ByVal lLicence As Long) As Long
Declare Function sFTPRemoveFile Lib "SapphireFTP.dll" (ByVal sRemoteFile As String, ByVal lLicence As Long) As Long
Declare Function sFTPRenameFile Lib "SapphireFTP.dll" (ByVal sOldFile As String, ByVal sNewFile As String, ByVal lLicence As Long) As Long
Declare Function sFTPRemoveDirectory Lib "SapphireFTP.dll" (ByVal sDirectory As String, ByVal lLicence As Long) As Long
Declare Function sFTPMakeDirectory Lib "SapphireFTP.dll" (ByVal sDirectory As String, ByVal lLicence As Long) As Long

Declare Function sFTPUploadDirectory Lib "SapphireFTP.dll" (ByVal sLocalDirectory As String, ByVal lLicence As Long) As Long
Declare Function sFTPDownloadDirectory Lib "SapphireFTP.dll" (ByVal sRemoteDirectory As String, ByVal sLocalPath As String, ByVal lLicence As Long) As Long

Declare Sub sFTPErrorText Lib "SapphireFTP.dll" (ByVal sErrorText As String, ByVal lError As Long)
Declare Function sFTPReconnect Lib "SapphireFTP.dll" (ByVal lPassive As Long, ByVal lLicence As Long) As Long

Public sLocalPath As String

Public Type FTPFile
    Filename As String
    Size As Long
    Date As String
    IsDirectory As Boolean
End Type

Public Function FTPOpen(sServer As String, lPort As Long, sUser As String, sPassword As String, bPassive As Boolean, lTimeout As Long) As Long
    FTPOpen = sFTPOpen(sServer, lPort, sUser, sPassword, IIf(bPassive, 1, 0), lTimeout, SapphireFTPLicence)
End Function

Public Function FTPClose() As Long
    FTPClose = sFTPClose(SapphireFTPLicence)
End Function

Public Function FTPUploadFile(sLocalFile As String, sRemoteFile As String, lTransferType As Long) As Long
    FTPUploadFile = sFTPPut(sLocalFile, sRemoteFile, lTransferType, SapphireFTPLicence)
End Function

Public Function FTPDownloadFile(sRemoteFile As String, sLocalFile As String, bOverWrite As Boolean, lTransferType As Long) As Long
    FTPDownloadFile = sFTPGet(sRemoteFile, sLocalFile, IIf(bOverWrite, 1, 0), lTransferType, SapphireFTPLicence)
End Function

Public Function FTPRemoveFile(sRemoteFile As String)
    FTPRemoveFile = sFTPRemoveFile(sRemoteFile, SapphireFTPLicence)
End Function

Public Function FTPErrorText(lVal As Long) As String
    Dim sError As String
    
    sError = String(1024, Chr(0))
    sFTPErrorText sError, lVal
      
    FTPErrorText = sError
End Function

Public Function FTPCurrentDirectory() As String
    Dim sReturn As String
    
    sReturn = String(260, Chr(0))
    
    If sFTPCurrentDirectory(sReturn, SapphireFTPLicence) = 0 Then
        sReturn = "/"
    Else
        sReturn = sReturn
    End If
    FTPCurrentDirectory = sReturn
End Function

Public Function FTPFindFirstFile(Optional sRemoteFilter As String = "") As FTPFile
    Dim sFile As String
    Dim file As FTPFile
        
    sFile = String(1024, Chr(0))
    If sFTPFindFirstFile(sFile, sRemoteFilter, SapphireFTPLicence) = 0 Then
        sFile = ""
    End If
    
    FTPFindFirstFile = PopulateFileProperties(sFile)
End Function

Public Function FTPFindNextFile() As FTPFile
    Dim sFile As String
    Dim file As FTPFile
    
    sFile = String(1024, Chr(0))
    If sFTPFindNextFile(sFile, SapphireFTPLicence) = 0 Then
        sFile = ""
    End If
    FTPFindNextFile = PopulateFileProperties(sFile)
End Function

Private Function PopulateFileProperties(sFileInfo As String) As FTPFile
    Dim file As FTPFile
    Dim elements() As String
     
    elements = Split(sFileInfo, "|")
    If (UBound(elements) = 6) Then
        file.Filename = elements(0)
        file.Date = elements(4)
        file.Size = CLng(elements(1))
        file.IsDirectory = InStr(1, elements(5), "DIR") > 0
    Else
        file.Filename = ""
        file.Date = ""
        file.Size = 0
        file.IsDirectory = False
    End If
    
    PopulateFileProperties = file
End Function
