Imports System.IO
Imports System.Threading.Thread
Imports System.Runtime.InteropServices

Module FTP
    ' Error codes
    Public Const FTP_NO_ERROR = 0
    Public Const FTP_TOO_MANY_INTERNET_HANDLES = 1
    Public Const FTP_TIMEOUT = 2
    Public Const FTP_INTERNAL_ERROR = 3
    Public Const FTP_INVALID_URL = 4
    Public Const FTP_NAME_NOT_RESOLVED = 5
    Public Const FTP_PROTOCOL_NOT_FOUND = 6
    Public Const FTP_SHUTDOWN = 7
    Public Const FTP_INCORRECT_USER_NAME = 8
    Public Const FTP_INCORRECT_PASSWORD = 9
    Public Const FTP_LOGIN_FAILED = 10
    Public Const FTP_REQUEST_PENDING = 11
    Public Const FTP_CANNOT_CONNECT = 12
    Public Const FTP_CONNECTION_ABORTED = 13
    Public Const FTP_CONNECTION_RESET = 14
    Public Const FTP_FORCE_RETRY = 15
    Public Const FTP_INVALID_PROXY_REQUEST = 16
    Public Const FTP_TRANSFER_IN_PROGRESS = 17
    Public Const FTP_DROPPED = 18
    Public Const FTP_NO_PASSIVE_MODE = 19
    Public Const FTP_LOCAL_FILE_EXISTS = 20
    Public Const FTP_UNKNOWN = 21

    ' Overwrite modes
    Public Const FTP_OVERWRITE = 1
    Public Const FTP_DONT_OVERWRITE = 0

    ' Transfer modes
    Public Const FTP_TRANSFER_UNKNOWN = 0
    Public Const FTP_TRANSFER_ASCII = 1
    Public Const FTP_TRANSFER_BINARY = 2

    Public Const DEFAULT_FTP_PORT = 21

    ' FTP Settings
    Public sFTPSession As String
    Public sFTPUsername As String
    Public sFTPPassword As String
    Public sURL As String
    Public sLocalFilter As String
    Public sRemoteFilter As String

    Public sSessions(3) As String
    Public sUsernames(3) As String
    Public sPasswords(3) As String
    Public iPassive As Integer
    Public sLocalPath As String

    <DllImport("SapphireFTP.dll")> _
    Public Function sFTPOpen(ByVal sServer As String, ByVal iPort As Integer, ByVal sUser As String, ByVal sPwd As String, ByVal iPassive As Integer, ByVal iTimeOut As Integer, ByVal iLicence As Integer) As Integer
    End Function

    <DllImport("SapphireFTP.dll")> _
    Public Function sFTPGet(ByVal sRemoteFile As String, ByVal sLocalFile As String, ByVal bOverWriteFile As Byte, ByVal iTransferType As Integer, ByVal iLicence As Integer) As Integer
    End Function

    <DllImport("SapphireFTP.dll")> _
    Public Function sFTPPull(ByVal sRemoteFile As String, ByVal sLocalFile As String, ByVal bOverWriteFile As Byte, ByVal iTransferType As Integer, ByVal iLicence As Integer) As Integer
    End Function

    <DllImport("SapphireFTP.dll")> _
    Public Function sFTPPullStart(ByVal sRemoteFile As String, ByVal sLocalFile As String, ByVal bOverWriteFile As Byte, ByVal iTransferType As Integer, ByVal iLicence As Integer) As Integer
    End Function

    <DllImport("SapphireFTP.dll")> _
    Public Function sFTPPullMore() As Integer
    End Function

    <DllImport("SapphireFTP.dll")> _
    Public Function sFTPPullEnd() As Integer
    End Function

    <DllImport("SapphireFTP.dll")> _
    Public Function sFTPPut(ByVal sLocalFile As String, ByVal sRemoteFile As String, ByVal iTransferType As Integer, ByVal iLicence As Integer) As Integer
    End Function

    <DllImport("SapphireFTP.dll")> _
    Public Function sFTPPush(ByVal sLocalFile As String, ByVal sRemoteFile As String, ByVal iTransferType As Integer, ByVal iLicence As Integer) As Integer
    End Function

    <DllImport("SapphireFTP.dll")> _
    Public Function sFTPPushStart(ByVal sLocalFile As String, ByVal sRemoteFile As String, ByVal iTransferType As Integer, ByVal iLicence As Integer) As Integer
    End Function

    <DllImport("SapphireFTP.dll")> _
    Public Function sFTPPushMore() As Integer
    End Function

    <DllImport("SapphireFTP.dll")> _
    Public Function sFTPPushEnd() As Integer
    End Function

    <DllImport("SapphireFTP.dll")> _
    Public Function sFTPClose(ByVal iLicense As Integer) As Integer
    End Function

    <DllImport("SapphireFTP.dll")> _
    Public Function sFTPChangeDirectory(ByVal sPath As String, ByVal iLicence As Integer) As Integer
    End Function

    <DllImport("SapphireFTP.dll")> _
    Public Function sFTPCurrentDirectory(ByVal sCurrentDirectory As String, ByVal iLicence As Integer) As Integer
    End Function

    <DllImport("SapphireFTP.dll")> _
    Public Function sFTPFileExists(ByVal sFile As String, ByVal iLicence As Integer) As Integer
    End Function

    <DllImport("SapphireFTP.dll")> _
    Public Function sFTPFindFirstFile(ByVal sFileString As String, ByVal sFilter As String, ByVal iLicence As Integer) As Integer
    End Function

    <DllImport("SapphireFTP.dll")> _
    Public Function sFTPFindNextFile(ByVal sFileString As String, ByVal iLicence As Integer) As Integer
    End Function

    <DllImport("SapphireFTP.dll")> _
    Public Function sFTPRemoveFile(ByVal sRemoteFile As String, ByVal iLicence As Integer) As Integer
    End Function

    <DllImport("SapphireFTP.dll")> _
    Public Function sFTPRenameFile(ByVal sOldFile As String, ByVal sNewFile As String, ByVal iLicence As Integer) As Integer
    End Function

    <DllImport("SapphireFTP.dll")> _
    Public Function sFTPRemoveDirectory(ByVal sDirectory As String, ByVal iLicence As Integer) As Integer
    End Function

    <DllImport("SapphireFTP.dll")> _
    Public Function sFTPMakeDirectory(ByVal sDirectory As String, ByVal iLicence As Integer) As Integer
    End Function

    <DllImport("SapphireFTP.dll")> _
    Public Function sFTPUploadDirectory(ByVal sLocalDirectory As String, ByVal iLicence As Integer) As Integer
    End Function

    <DllImport("SapphireFTP.dll")> _
    Public Function sFTPDownloadDirectory(ByVal sRemoteDirectory As String, ByVal sLocalPath As String, ByVal iLicence As Integer) As Integer
    End Function

    <DllImport("SapphireFTP.dll")> _
    Public Sub sFTPErrorText(ByVal sErrorText As String, ByVal iError As Integer)
    End Sub

    <DllImport("SapphireFTP.dll")> _
    Public Function sFTPReconnect(ByVal iPassive As Integer, ByVal iLicence As Integer) As Integer
    End Function

    Public Function InitialiseFileManager()
        sLocalPath = "\"
    End Function

    Public Sub SetFTPSettings()
        fSetFTP.cboSession.Items.Clear()

        ' Set up the default settings for FTP Web site
        sSessions(1) = "ftp.sapphire-solutions.co.uk"
        sUsernames(1) = "sapphirepublic"
        sPasswords(1) = "solutions"
        fSetFTP.cboSession.Items.Add(New ListItem(sSessions(1), 1))

        sSessions(2) = "pentium4"
        sUsernames(2) = "anonymous"
        sPasswords(2) = "sales@sapphire-solutions.co.uk"
        fSetFTP.cboSession.Items.Add(New ListItem(sSessions(2), 2))

        ' Make the first one the default
        fSetFTP.cboSession.SelectedIndex = 0
        fSetFTP.txtUsername.Text = sUsernames(1)
        fSetFTP.txtPassword.Text = sPasswords(1)

        sFTPSession = sSessions(1)
        sFTPUsername = sUsernames(1)
        sFTPPassword = sPasswords(1)
    End Sub

    Public Function sLocalChangeDirectory(ByVal sDirectory As String) As Integer
        Dim sDir As String
        Dim iCounter As Integer

        sLocalChangeDirectory = 1

        If sDirectory = ".." Then
            If sLocalPath <> "\" Then
                ' Remove the last folder in the string
                sDir = Mid(sLocalPath, 1, Len(sLocalPath) - 1)
                iCounter = Len(sDir)
                While Mid(sDir, iCounter, 1) <> "\" And iCounter > 0
                    sDir = Mid(sDir, 1, iCounter - 1)
                    iCounter = iCounter - 1
                End While

                sLocalPath = sDir
                sLocalChangeDirectory = 0
            End If
        Else
            sLocalPath = sLocalPath & sDirectory & "\"
            sLocalChangeDirectory = 0
        End If
    End Function

    Public Function sLocalCurrentDirectory() As String
        sLocalCurrentDirectory = sLocalPath
    End Function

    Public Sub sLocalRefreshList()
        Dim liFile As ListViewItem
        Dim fsDir As New DirectoryInfo(sLocalPath)
        Dim sFiles() As FileInfo
        Dim sDirectories() As DirectoryInfo
        Dim iCount As Integer

        fFTPExplorer.lstLocal.Items.Clear()

        fFTPExplorer.lblLocal.Text = "Local Directory: " & sLocalPath & sLocalFilter

        If sLocalPath <> "\" Then
            liFile = New ListViewItem("[..]")
            liFile.SubItems.Add("")
            liFile.SubItems.Add("")
            liFile.SubItems.Add("DIR")
            liFile = fFTPExplorer.lstLocal.Items.Add(liFile)
        End If

        ' Get all the sub directories
        Try ' GetDirectories crashes if there are no contents in the folder
            sDirectories = fsDir.GetDirectories()
            For iCount = 0 To UBound(sDirectories)
                liFile = New ListViewItem("[" & sDirectories(iCount).Name & "]")
                ' Get the size
                liFile.SubItems.Add("")
                ' Get the date
                liFile.SubItems.Add(FormatDateTime(sDirectories(iCount).CreationTime, DateFormat.GeneralDate))
                ' Get the attributes of the directory
                liFile.SubItems.Add(GetDirectoryAttributes(sDirectories(iCount)))
                fFTPExplorer.lstLocal.Items.Add(liFile)
            Next
        Catch ex As Exception
        End Try

        Try
            sFiles = fsDir.GetFiles(sLocalFilter)
            For iCount = 0 To UBound(sFiles)
                liFile = New ListViewItem(sFiles(iCount).Name)
                ' Get the size
                liFile.SubItems.Add(GetFileSizeText(sFiles(iCount).Length))
                ' Get the date
                liFile.SubItems.Add(FormatDateTime(sFiles(iCount).CreationTime, DateFormat.GeneralDate))
                ' Get the attributes of the directory
                liFile.SubItems.Add(GetFileAttributes(sFiles(iCount)))
                fFTPExplorer.lstLocal.Items.Add(liFile)
            Next
        Catch ex As Exception
        End Try

        'fFTPExplorer.lstLocal.Sorted = True
    End Sub

    Public Function sLocalRemoveFile(ByVal sLocalFile As String) As Integer
        Dim sFile As New FileInfo(sLocalPath & sLocalFile)
        Dim iReturn As Integer

        On Error Resume Next

        Err.Clear()

        sFile.Delete()

        If Err.Number > 0 Then
            iReturn = Err.Number
        Else
            iReturn = 0
        End If

        On Error GoTo 0

        sLocalRemoveFile = iReturn
    End Function

    Public Function sLocalRenameFile(ByVal sOldFile As String, ByVal sNewFile As String) As Integer
        Dim sFile As New FileInfo(sLocalPath & sOldFile)
        Dim iReturn As Integer

        On Error Resume Next

        Err.Clear()

        sFile.MoveTo(sLocalPath & sNewFile)

        If Err.Number > 0 Then
            iReturn = Err.Number
        Else
            iReturn = 0
        End If

        On Error GoTo 0

        sLocalRenameFile = iReturn
    End Function

    Public Function sLocalRemoveDirectory(ByVal sDirectory As String) As Integer
        Dim fsDir As New DirectoryInfo(sLocalPath & sDirectory)
        Dim sFiles() As FileInfo
        Dim sDirectories() As DirectoryInfo
        Dim iCount As Integer

        ' Search for all sub directories and remove their content
        Try ' GetDirectories crashes if there are no contents in the folder
            sDirectories = fsDir.GetDirectories()
            For iCount = 0 To UBound(sDirectories)
                sLocalRemoveDirectory(sDirectory & "\" & sDirectories(iCount).Name)
            Next
        Catch
            Return 1
        End Try

        ' Remove all the files in this directory
        Try
            sFiles = fsDir.GetFiles()
            For iCount = 0 To UBound(sFiles)
                sFiles(iCount).Delete()
            Next
        Catch
            Return 1
        End Try

        ' Remove this directory
        fsDir.Delete(False)
        Return 0
    End Function

    Public Function sLocalMakeDirectory(ByVal sDirectory As String) As Integer
        Dim fsDir As New DirectoryInfo(sLocalPath)

        On Error Resume Next

        Err.Clear()
        fsDir.CreateSubdirectory(sDirectory)
        If Err.Number <> 0 Then
            sLocalMakeDirectory = 1
        Else
            sLocalMakeDirectory = 0
        End If
        On Error GoTo 0
    End Function

    Public Function GetFileSizeText(ByVal iSize As Integer) As String
        If iSize < 1024 Then
            If iSize = 1 Then
                GetFileSizeText = "1 byte"
            Else
                GetFileSizeText = iSize & " bytes"
            End If
        Else
            If iSize < 1024 * 1024 Then
                GetFileSizeText = CLng(iSize / 1024) & " KB"
            Else
                GetFileSizeText = CLng(iSize / (1024 * 1024)) & " MB"
            End If
        End If
    End Function

    Private Function GetDirectoryAttributes(ByVal sDir As DirectoryInfo) As String
        Dim sAttributes As String
        Dim bComma As Boolean

        bComma = False
        sAttributes = ""

        If sDir.Attributes = FileAttributes.ReadOnly Then
            If bComma = True Then
                sAttributes = ",RD"
            Else
                sAttributes = "RD"
            End If
            bComma = True
        End If
        If sDir.Attributes = FileAttributes.Hidden Then
            If bComma = True Then
                sAttributes = ",HID"
            Else
                sAttributes = "HID"
            End If
            bComma = True
        End If
        If sDir.Attributes = FileAttributes.System Then
            If bComma = True Then
                sAttributes = ",SYS"
            Else
                sAttributes = "SYS"
            End If
            bComma = True
        End If

        If bComma = True Then
            sAttributes = ",DIR"
        Else
            sAttributes = "DIR"
        End If
        bComma = True

        If sDir.Attributes = FileAttributes.Archive Then
            If bComma = True Then
                sAttributes = ",ARC"
            Else
                sAttributes = "ARC"
            End If
            bComma = True
        End If

        GetDirectoryAttributes = sAttributes
    End Function

    Private Function GetFileAttributes(ByVal sFile As FileInfo) As String
        Dim sAttributes As String
        Dim bComma As Boolean

        bComma = False
        sAttributes = ""

        If sFile.Attributes = FileAttributes.ReadOnly Then
            If bComma = True Then
                sAttributes = ",RD"
            Else
                sAttributes = "RD"
            End If
            bComma = True
        End If
        If sFile.Attributes = FileAttributes.Hidden Then
            If bComma = True Then
                sAttributes = ",HID"
            Else
                sAttributes = "HID"
            End If
            bComma = True
        End If
        If sFile.Attributes = FileAttributes.System Then
            If bComma = True Then
                sAttributes = ",SYS"
            Else
                sAttributes = "SYS"
            End If
            bComma = True
        End If
        If sFile.Attributes = FileAttributes.Archive Then
            If bComma = True Then
                sAttributes = ",ARC"
            Else
                sAttributes = "ARC"
            End If
            bComma = True
        End If

        GetFileAttributes = sAttributes
    End Function

    Public Function sLocalFileExists(ByVal sLocalFile As String) As Boolean
        Dim sFile As New FileInfo(sLocalFile)
        sLocalFileExists = sFile.Exists()
    End Function

    Public Function GetFTPError(ByVal iError As Integer) As String
        Dim sErrorText As String = Space(1024)
        sFTPErrorText(sErrorText, iError)
        GetFTPError = StripString(sErrorText)
    End Function

    Public Function FTPCurrentDirectory() As String
        Dim sReturn As String = Space(260)

        If sFTPCurrentDirectory(sReturn, SapphireFTPLicence) = 0 Then
            sReturn = "/"
        End If
        FTPCurrentDirectory = StripString(sReturn)
    End Function

    Public Function FTPFindFirstFile(ByVal sRemoteFilter As String) As String
        Dim sFile As String = Space(1024)
        If sFTPFindFirstFile(sFile, sRemoteFilter, SapphireFTPLicence) = 0 Then
            sFile = ""
        End If
        FTPFindFirstFile = StripString(sFile)
    End Function

    Public Function FTPFindNextFile() As String
        Dim sFile As String = Space(1024)
        If sFTPFindNextFile(sFile, SapphireFTPLicence) = 0 Then
            sFile = ""
        End If
        FTPFindNextFile = StripString(sFile)
    End Function
End Module
